diff --git a/src/app/gps/qgsgpsinformationwidget.cpp b/src/app/gps/qgsgpsinformationwidget.cpp
index ab9bc1e..56465f9 100644
--- a/src/app/gps/qgsgpsinformationwidget.cpp
+++ b/src/app/gps/qgsgpsinformationwidget.cpp
@@ -18,6 +18,7 @@
 #include "qgsnmeaconnection.h"
 #include "qgsgpsconnectionregistry.h"
 #include "qgsgpsdetector.h"
+#include "info.h"
 #include "qgscoordinatetransform.h"
 #include <qgspoint.h>
 #include <qgsrubberband.h>
@@ -29,6 +30,7 @@
 #include "qgslogger.h"
 #include "qgsfeatureaction.h"
 #include "qgsgeometry.h"
+#include <qgisapp.h>
 
 //for avoid intersections static method
 #include "qgsmaptooladdfeature.h"
@@ -39,7 +41,6 @@
 #include <qwt_plot.h>
 #include <qwt_plot_grid.h>
 // QWT Polar plot add on
-#include <qpen.h>
 #include <qwt_data.h>
 #include <qwt_symbol.h>
 #include <qwt_polar_grid.h>
@@ -49,9 +50,10 @@
 #include <QMessageBox>
 #include <QSettings>
 #include <QFileInfo>
-#include <QPointF>
+//#include <QPointF>
 #include <QColorDialog>
-
+#include <QFileDialog>
+#include <QPixmap>
 
 QgsGPSInformationWidget::QgsGPSInformationWidget( QgsMapCanvas * thepCanvas, QWidget * parent, Qt::WindowFlags f ):
     QWidget( parent, f ),
@@ -59,6 +61,13 @@ QgsGPSInformationWidget::QgsGPSInformationWidget( QgsMapCanvas * thepCanvas, QWi
     mpCanvas( thepCanvas )
 {
   setupUi( this );
+
+  // to connect signals that layers have changed (which layer, edit state)
+  mpLegend = QgisApp::instance()->legend();
+  mpLastLayer = 0;
+
+  mLastGpsPosition = QgsPoint( 0.0, 0.0 );
+
   mpMapMarker = 0;
   mpRubberBand = 0;
   populateDevices();
@@ -67,13 +76,14 @@ QgsGPSInformationWidget::QgsGPSInformationWidget( QgsMapCanvas * thepCanvas, QWi
   // Set up the graph for signal strength
   //
   mpPlot = new QwtPlot( mpHistogramWidget );
+  mpPlot->setAutoReplot( false );   // plot on demand
   //mpPlot->setTitle(QObject::tr("Signal Status"));
   //mpPlot->insertLegend(new QwtLegend(), QwtPlot::BottomLegend);
   // Set axis titles
   //mpPlot->setAxisTitle(QwtPlot::xBottom, QObject::tr("Satellite"));
   //mpPlot->setAxisTitle(QwtPlot::yLeft, QObject::tr("Value"));
   mpPlot->setAxisScale( QwtPlot::xBottom, 0, 20 );
-  mpPlot->setAxisScale( QwtPlot::yLeft, 0, 100 );
+  mpPlot->setAxisScale( QwtPlot::yLeft, 0, 100 );  // max is 50dB SNR, I believe - SLM
   // add a grid
   //QwtPlotGrid * mypGrid = new QwtPlotGrid();
   //mypGrid->attach( mpPlot );
@@ -96,43 +106,47 @@ QgsGPSInformationWidget::QgsGPSInformationWidget( QgsMapCanvas * thepCanvas, QWi
   // Set up the polar graph for satellite pos
   //
   QWidget * mpPolarWidget = mStackedWidget->widget( 2 );
-  //mpSatellitesWidget = new QwtPolarPlot(QwtText(tr("Satellite Positions")), myTab );
-  mpSatellitesWidget = new QwtPolarPlot( mpPolarWidget );
-  mpSatellitesWidget->setAutoReplot( true );
+  mpSatellitesWidget = new QwtPolarPlot( /*QwtText( tr( "Satellite View" ), QwtText::PlainText ),*/ mpPolarWidget );  // possible title for graph removed for now as it is too large in small windows
+  mpSatellitesWidget->setAutoReplot( false  );  // plot on demand (after all data has been handled)
   mpSatellitesWidget->setPlotBackground( Qt::white );
   // scales
-  mpSatellitesWidget->setScale( QwtPolar::Azimuth,
-                                0, //min
-                                360, //max
-                                30 //interval
+  mpSatellitesWidget->setScale( QwtPolar::ScaleAzimuth,
+                                360, //min - reverse the min/max values to get compass orientation - increasing clockwise
+                                0, //max
+                                90 //interval - just show cardinal and intermediate (NE, N, NW, etc.) compass points (in degrees)
                               );
+  mpSatellitesWidget->setAzimuthOrigin( M_PI_2 );    // to get compass orientation - need to rotate 90 deg. ccw; this is in Radians (not indicated in QwtPolarPlot docs)
 
-  mpSatellitesWidget->setScaleMaxMinor( QwtPolar::Azimuth, 10 );
-  mpSatellitesWidget->setScale( QwtPolar::Radius,
-                                0, //min
-                                100 //max
+//  mpSatellitesWidget->setScaleMaxMinor( QwtPolar::ScaleRadius, 2 );  // seems unnecessary
+  mpSatellitesWidget->setScale( QwtPolar::ScaleRadius,
+                                90, //min - reverse the min/max to get 0 at edge, 90 at center
+                                0, //max
+                                45 //interval
                               );
 
   // grids, axes
 
   QwtPolarGrid * mypSatellitesGrid = new QwtPolarGrid();
+  mypSatellitesGrid->setGridAttribute( QwtPolarGrid::AutoScaling, false );   // This fixes the issue of autoscaling on the Radius grid. It is ON by default AND is separate from the scaleData.doAutoScale in QwtPolarPlot::setScale(), etc. THIS IS VERY TRICKY!
   mypSatellitesGrid->setPen( QPen( Qt::black ) );
+  QPen minorPen( Qt::gray );  // moved outside of for loop; NOTE setting the minor pen isn't necessary if the minor grids aren't shown
   for ( int scaleId = 0; scaleId < QwtPolar::ScaleCount; scaleId++ )
   {
-    mypSatellitesGrid->showGrid( scaleId );
+    //mypSatellitesGrid->showGrid( scaleId );
     //mypSatellitesGrid->showMinorGrid(scaleId);
-    QPen minorPen( Qt::gray );
     mypSatellitesGrid->setMinorGridPen( scaleId, minorPen );
   }
-  mypSatellitesGrid->setAxisPen( QwtPolar::AxisAzimuth, QPen( Qt::black ) );
+//  mypSatellitesGrid->setAxisPen( QwtPolar::AxisAzimuth, QPen( Qt::black ) );
 
   mypSatellitesGrid->showAxis( QwtPolar::AxisAzimuth, true );
   mypSatellitesGrid->showAxis( QwtPolar::AxisLeft, false ); //alt axis
   mypSatellitesGrid->showAxis( QwtPolar::AxisRight, false );//alt axis
   mypSatellitesGrid->showAxis( QwtPolar::AxisTop, false );//alt axis
   mypSatellitesGrid->showAxis( QwtPolar::AxisBottom, false );//alt axis
-  mypSatellitesGrid->showGrid( QwtPolar::Azimuth, true );
-  mypSatellitesGrid->showGrid( QwtPolar::Radius, true );
+  mypSatellitesGrid->showGrid( QwtPolar::ScaleAzimuth, false ); // hide the grid; just show ticks at edge
+  mypSatellitesGrid->showGrid( QwtPolar::ScaleRadius, true );
+//  mypSatellitesGrid->showMinorGrid( QwtPolar::ScaleAzimuth, true );
+  mypSatellitesGrid->showMinorGrid( QwtPolar::ScaleRadius, true );   // for 22.5, 67.5 degree circles
   mypSatellitesGrid->attach( mpSatellitesWidget );
 
   //QwtLegend *legend = new QwtLegend;
@@ -142,13 +156,21 @@ QgsGPSInformationWidget::QgsGPSInformationWidget( QgsMapCanvas * thepCanvas, QWi
   mpPolarLayout->addWidget( mpSatellitesWidget );
   mpPolarWidget->setLayout( mpPolarLayout );
 
+  // replot on command
+  mpSatellitesWidget->replot();
+  mpPlot->replot();
 
   // Restore state
   QSettings mySettings;
+  mGroupShowMarker->setChecked(  mySettings.value( "/gps/showMarker", "true" ).toBool() );
   mSliderMarkerSize->setValue( mySettings.value( "/gps/markerSize", "12" ).toInt() );
   mSpinTrackWidth->setValue( mySettings.value( "/gps/trackWidth", "2" ).toInt() );
+  mTrackColour = mySettings.value( "/gps/trackColour", QColor( Qt::red ) ).value<QColor>();
   QString myPortMode = mySettings.value( "/gps/portMode", "scanPorts" ).toString();
 
+  mSpinMapExtentMultiplier->setValue( mySettings.value( "/gps/mapExtentMultiplier", "50" ).toInt() );
+  mDateTimeFormat = mySettings.value( "/gps/dateTimeFormat", "" ).toString(); // zero-length string signifies default format
+
   mGpsdHost->setText( mySettings.value( "/gps/gpsdHost", "localhost" ).toString() );
   mGpsdPort->setText( mySettings.value( "/gps/gpsdPort", 2947 ).toString() );
   mGpsdDevice->setText( mySettings.value( "/gps/gpsdDevice" ).toString() );
@@ -166,9 +188,12 @@ QgsGPSInformationWidget::QgsGPSInformationWidget( QgsMapCanvas * thepCanvas, QWi
   {
     mRadGpsd->setChecked( true );
   }
+
   //auto digitising behaviour
-  bool myAutoAddVertexFlag = mySettings.value( "/gps/autoAddVertices", "false" ).toBool();
-  mCbxAutoAddVertices->setChecked( myAutoAddVertexFlag );
+  mCbxAutoAddVertices->setChecked( mySettings.value( "/gps/autoAddVertices", "false" ).toBool() );
+
+  mCbxAutoCommit->setChecked( mySettings.value( "/gps/autoCommit", "false" ).toBool() );
+
   //pan mode
   QString myPanMode = mySettings.value( "/gps/panMode", "recenterWhenNeeded" ).toString();
   if ( myPanMode == "none" )
@@ -184,25 +209,45 @@ QgsGPSInformationWidget::QgsGPSInformationWidget( QgsMapCanvas * thepCanvas, QWi
     radRecenterWhenNeeded->setChecked( true );
   }
   // Set up the rubber band to show digitising
-  createRubberBand();
+
   mWgs84CRS.createFromOgcWmsCrs( "EPSG:4326" );
-  //for now I am hiding accuracy and date widgets
-  mDateTime->hide();
-  mVerticalAccuracy->hide();
-  mHorizontalAccuracy->hide();
-  mBtnDebug->hide();
+
+  mBtnDebug->setVisible(mySettings.value( "/gps/showDebug", "false" ).toBool());  // use a registry setting to control - power users/devs could set it
+
+  // status = unknown
+  setStatusIndicator( NoData );
+
+  //SLM - added functionality
+  mLogFile = 0;
+
+  connect( mpLegend, SIGNAL( currentLayerChanged( QgsMapLayer* ) ),
+           this, SLOT( updateCloseFeatureButton( QgsMapLayer* ) ) );
+
+  mStackedWidget->setCurrentIndex( 3 ); // force to Options
+  mBtnPosition->setFocus( Qt::TabFocusReason );
 }
 
 QgsGPSInformationWidget::~QgsGPSInformationWidget()
 {
+  if ( mNmea )
+  {
+      disconnectGps();
+  }
+
   if ( mpMapMarker )
     delete mpMapMarker;
 
   QSettings mySettings;
   mySettings.setValue( "/gps/lastPort", mCboDevices->itemData( mCboDevices->currentIndex() ).toString() );
   mySettings.setValue( "/gps/trackWidth", mSpinTrackWidth->value() );
+  mySettings.setValue( "/gps/trackColour", mTrackColour );
   mySettings.setValue( "/gps/markerSize", mSliderMarkerSize->value() );
+  mySettings.setValue( "/gps/showMarker", mGroupShowMarker->isChecked() );
   mySettings.setValue( "/gps/autoAddVertices", mCbxAutoAddVertices->isChecked() );
+  mySettings.setValue( "/gps/autoCommit", mCbxAutoCommit->isChecked() );
+
+  mySettings.setValue( "/gps/mapExtentMultiplier", mSpinMapExtentMultiplier->value() );
+
   // scan, explicit port or gpsd
   if ( mRadAutodetect->isChecked() )
   {
@@ -243,8 +288,6 @@ QgsGPSInformationWidget::~QgsGPSInformationWidget()
 
 void QgsGPSInformationWidget::on_mSpinTrackWidth_valueChanged( int theValue )
 {
-  QSettings mySettings;
-  mySettings.setValue( "/gps/trackWidth", theValue );
   if ( mpRubberBand )
   {
     mpRubberBand->setWidth( theValue );
@@ -253,18 +296,18 @@ void QgsGPSInformationWidget::on_mSpinTrackWidth_valueChanged( int theValue )
 
 void QgsGPSInformationWidget::on_mBtnTrackColour_clicked( )
 {
-  QSettings mySettings;
-  QColor myColor( mySettings.value( "/qgis/gps/line_color_red", 255 ).toInt(),
-                  mySettings.value( "/qgis/gps/line_color_green", 0 ).toInt(),
-                  mySettings.value( "/qgis/gps/line_color_blue", 0 ).toInt() );
-  myColor = QColorDialog::getColor( myColor, this );
-  mySettings.setValue( "/qgis/gps/line_color_red", myColor.red() );
-  mySettings.setValue( "/qgis/gps/line_color_green", myColor.green() );
-  mySettings.setValue( "/qgis/gps/line_color_blue", myColor.blue() );
-  setTrackColour();
+  QColor myColor = QColorDialog::getColor( mTrackColour, this );
+  if ( myColor.isValid() )  // check that a color was picked
+  {
+    mTrackColour = myColor;
+    if ( mpRubberBand )
+    {
+      mpRubberBand->setColor( myColor );
+    }
+  }
 }
 
-
+#if 0 //no longer used
 void QgsGPSInformationWidget::setTrackColour( )
 {
   QSettings mySettings;
@@ -276,19 +319,24 @@ void QgsGPSInformationWidget::setTrackColour( )
     mpRubberBand->setColor( myColor );
   }
 }
+#endif
+
 void QgsGPSInformationWidget::on_mBtnPosition_clicked( )
 {
   mStackedWidget->setCurrentIndex( 0 );
+  if ( mNmea ) displayGPSInformation( mNmea->currentGPSInformation() );
 }
 
 void QgsGPSInformationWidget::on_mBtnSignal_clicked( )
 {
   mStackedWidget->setCurrentIndex( 1 );
+  if ( mNmea ) displayGPSInformation( mNmea->currentGPSInformation() );
 }
 
 void QgsGPSInformationWidget::on_mBtnSatellites_clicked( )
 {
   mStackedWidget->setCurrentIndex( 2 );
+  if ( mNmea ) displayGPSInformation( mNmea->currentGPSInformation() );
 }
 
 void QgsGPSInformationWidget::on_mBtnOptions_clicked( )
@@ -315,6 +363,24 @@ void QgsGPSInformationWidget::on_mConnectButton_toggled( bool theFlag )
 
 void QgsGPSInformationWidget::connectGps()
 {
+  // clear position page fields to give better indication that something happened (or didn't happen)
+  mTxtLatitude->clear();
+  mTxtLongitude->clear();
+  mTxtAltitude->clear();
+  mTxtDateTime->clear();
+  mTxtSpeed->clear();
+  mTxtDirection->clear();
+  mTxtHdop->clear();
+  mTxtVdop->clear();
+  mTxtPdop->clear();
+  mTxtFixMode->clear();
+  mTxtFixType->clear();
+  mTxtQuality->clear();
+  mTxtSatellitesUsed->clear();
+  mTxtStatus->clear();
+
+  mLastGpsPosition = QgsPoint( 0.0, 0.0 );
+
   QString port;
 
   if ( mRadUserPath->isChecked() )
@@ -335,18 +401,21 @@ void QgsGPSInformationWidget::connectGps()
     port = QString( "%1:%2:%3" ).arg( mGpsdHost->text() ).arg( mGpsdPort->text() ).arg( mGpsdDevice->text() );
   }
 
-  mGPSTextEdit->append( tr( "Connecting..." ) );
+  mGPSPlainTextEdit->appendPlainText( tr( "Connecting..." ) );
+  showStatusBarMessage( tr( "Connecting to GPS device..." ) );
 
   QgsGPSDetector *detector = new QgsGPSDetector( port );
   connect( detector, SIGNAL( detected( QgsGPSConnection * ) ), this, SLOT( connected( QgsGPSConnection * ) ) );
   connect( detector, SIGNAL( detectionFailed() ), this, SLOT( timedout() ) );
+  detector->advance();   // start the detection process
 }
 
 void QgsGPSInformationWidget::timedout()
 {
   mConnectButton->setChecked( false );
   mNmea = NULL;
-  mGPSTextEdit->append( tr( "Timed out!" ) );
+  mGPSPlainTextEdit->appendPlainText( tr( "Timed out!" ) );
+  showStatusBarMessage( tr( "Failed to connect to GPS device." ) );
 }
 
 void QgsGPSInformationWidget::connected( QgsGPSConnection *conn )
@@ -354,158 +423,328 @@ void QgsGPSInformationWidget::connected( QgsGPSConnection *conn )
   mNmea = conn;
   QObject::connect( mNmea, SIGNAL( stateChanged( const QgsGPSInformation& ) ),
                     this, SLOT( displayGPSInformation( const QgsGPSInformation& ) ) );
-  mGPSTextEdit->append( tr( "Connected!" ) );
-  mConnectButton->setText( tr( "Disconnect" ) );
+  mGPSPlainTextEdit->appendPlainText( tr( "Connected!" ) );
+  mConnectButton->setText( tr( "Dis&connect" ) );
   //insert connection into registry such that it can also be used by other dialogs or plugins
   QgsGPSConnectionRegistry::instance()->registerConnection( mNmea );
+  showStatusBarMessage( tr( "Connected to GPS device." ) );
+
+  if ( mLogFileGroupBox->isChecked() && ! mTxtLogFile->text().isEmpty() )
+  {
+    if ( ! mLogFile )
+    {
+      mLogFile = new QFile( mTxtLogFile->text() );
+    }
+
+    if ( mLogFile->open( QIODevice::Append ) )  // open in binary and explicitly output CR + LF per NMEA
+    {
+      mLogFileTextStream.setDevice( mLogFile );
+
+      // crude way to separate chunks - use when manually editing file - NMEA parsers should discard
+      mLogFileTextStream << "====" << "\r\n";
+
+      QObject::connect( mNmea, SIGNAL( nmeaSentenceReceived( const QString& ) ), this, SLOT( logNmeaSentence( const QString& ) ) ); // added to handle raw data
+    }
+    else  // error opening file
+    {
+      delete mLogFile;
+      mLogFile = 0;
+
+      // need to indicate why - this just reports that an error occurred
+      showStatusBarMessage( tr( "Error opening log file." ) );
+    }
+  }
 }
 
 void QgsGPSInformationWidget::disconnectGps()
 {
+  if ( mLogFile && mLogFile->isOpen() )
+  {
+    QObject::disconnect( mNmea, SIGNAL( nmeaSentenceReceived( const QString& ) ), this, SLOT( logNmeaSentence( const QString& ) ) );
+    mLogFile->close();
+    delete mLogFile;
+    mLogFile = 0;
+  }
+
   QgsGPSConnectionRegistry::instance()->unregisterConnection( mNmea );
   delete mNmea;
-  mGPSTextEdit->append( tr( "Disconnected..." ) );
+  mNmea = NULL;
+  if ( mpMapMarker )  // marker should not be shown on GPS disconnected - not current position
+  {
+    delete mpMapMarker;
+    mpMapMarker = NULL;
+  }
+  mGPSPlainTextEdit->appendPlainText( tr( "Disconnected..." ) );
   mConnectButton->setChecked( false );
-  mConnectButton->setText( tr( "Connect" ) );
-}
+  mConnectButton->setText( tr( "&Connect" ) );
+  showStatusBarMessage( tr( "Disconnected from GPS device." ) );
 
+  setStatusIndicator( NoData );
+
+}
 
 void QgsGPSInformationWidget::displayGPSInformation( const QgsGPSInformation& info )
 {
-  mGPSTextEdit->clear();
-
   QwtArray<double> myXData;//qwtarray is just a wrapped qvector
   QwtArray<double> mySignalData;//qwtarray is just a wrapped qvector
-  mpPlot->setAxisScale( QwtPlot::xBottom, 0, info.satellitesInView.size() );
-  while ( !mMarkerList.isEmpty() )
+
+  // set validity flag and status from GPS data
+  // based on GGA, GSA and RMC sentences - the logic does not require all
+  bool validFlag = false; // true if GPS indicates position fix
+  FixStatus fixStatus = NoData;
+
+  // no fix if any of the three report bad; default values are invalid values and won't be changed if the corresponding NMEA msg is not received
+  if ( info.status == 'V' || info.fixType == NMEA_FIX_BAD || info.quality == 0 ) // some sources say that 'V' indicates position fix, but is below acceptable quality
+  {
+    fixStatus = NoFix;
+  }
+  else if ( info.fixType == NMEA_FIX_2D ) // 2D indication (from GGA)
+  {
+    fixStatus = Fix2D;
+    validFlag = true;
+  }
+  else if ( info.status == 'A' || info.fixType == NMEA_FIX_3D || info.quality > 0 ) // good
+  {
+    fixStatus = Fix3D;
+    validFlag = true;
+  }
+  else  // unknown status (not likely)
   {
-    delete mMarkerList.takeFirst();
   }
 
-  for ( int i = 0; i < info.satellitesInView.size(); ++i )
+  // set visual status indicator -- do only on change of state
+  if ( fixStatus != mLastFixStatus )
   {
-    QgsSatelliteInfo currentInfo = info.satellitesInView.at( i );
+    setStatusIndicator( fixStatus );
+  }
 
-    myXData.append( i );
-    mySignalData.append( 0 );
-    myXData.append( i );
-    mySignalData.append( currentInfo.signal );
-    myXData.append( i + 1 );
-    mySignalData.append( currentInfo.signal );
-    myXData.append( i + 1 );
-    mySignalData.append( 0 );
-    mGPSTextEdit->append( "Satellite" );
-    if ( currentInfo.inUse )
+  if ( mStackedWidget->currentIndex() == 1 && info.satInfoComplete ) //signal
+  {
+    mpPlot->setAxisScale( QwtPlot::xBottom, 0, info.satellitesInView.size() );
+  } //signal
+
+  if ( mStackedWidget->currentIndex() == 2 && info.satInfoComplete ) //satellites
+  {
+    while ( !mMarkerList.isEmpty() )
     {
-      mGPSTextEdit->append( "In use" );
+      delete mMarkerList.takeFirst();
     }
-    else
+  } //satellites
+
+  if ( mStackedWidget->currentIndex() == 4 ) //debug
+  {
+    mGPSPlainTextEdit->clear();
+  } //debug
+
+  for ( int i = 0; i < info.satellitesInView.size(); ++i ) //satellite processing loop
+  {
+    QgsSatelliteInfo currentInfo = info.satellitesInView.at( i );
+
+    if ( mStackedWidget->currentIndex() == 1 && info.satInfoComplete ) //signal
     {
-      mGPSTextEdit->append( "Not in use" );
-    }
-    mGPSTextEdit->append( "id: " + QString::number( currentInfo.id ) );
-    mGPSTextEdit->append( "elevation: " + QString::number( currentInfo.elevation ) );
-    mGPSTextEdit->append( "azimuth: " + QString::number( currentInfo.azimuth ) );
-    mGPSTextEdit->append( "signal: " + QString::number( currentInfo.signal ) );
-    // Add a marker to the polar plot
-    QwtPolarMarker *mypMarker = new QwtPolarMarker();
-    mypMarker->setPosition( QwtPolarPoint( currentInfo.azimuth, currentInfo.elevation ) );
-    QColor myColour;
-    if ( currentInfo.signal < 30 ) //weak signal
+      myXData.append( i );
+      mySignalData.append( 0 );
+      myXData.append( i );
+      mySignalData.append( currentInfo.signal );
+      myXData.append( i + 1 );
+      mySignalData.append( currentInfo.signal );
+      myXData.append( i + 1 );
+      mySignalData.append( 0 );
+    } //signal
+
+#if 0
+    if ( mStackedWidget->currentIndex() == 4 ) //debug
     {
-      myColour = Qt::red;
-    }
-    else
+#if 0   // temporarily removed as the info isn't being set in GSA/GSV processing
+      //    mGPSPlainTextEdit->appendPlainText( "Satellite" );
+      if ( currentInfo.inUse )
+      {
+        mGPSPlainTextEdit->appendPlainText( "Satellite In use" );
+      }
+      else
+      {
+        mGPSPlainTextEdit->appendPlainText( "Satellite Not in use" );
+      }
+#endif
+#if 0
+      mGPSPlainTextEdit->appendPlainText( "id: " + QString::number( currentInfo.id ) );
+      mGPSPlainTextEdit->appendPlainText( "elevation: " + QString::number( currentInfo.elevation ) );
+      mGPSPlainTextEdit->appendPlainText( "azimuth: " + QString::number( currentInfo.azimuth ) );
+      mGPSPlainTextEdit->appendPlainText( "signal: " + QString::number( currentInfo.signal ) );
+#else // as a single line per satellite - easier to read
+      mGPSPlainTextEdit->appendPlainText( "sat: " + QString::number( currentInfo.id )
+      + ", elev: " + QString::number( currentInfo.elevation )
+      + ", azimuth: " + QString::number( currentInfo.azimuth )
+      + ", signal: " + QString::number( currentInfo.signal ) );
+#endif
+    } //debug
+#endif
+
+    if ( mStackedWidget->currentIndex() == 2 && info.satInfoComplete ) //satellites
     {
-      myColour = Qt::black; //strong signal
-    }
-    mypMarker->setSymbol( QwtSymbol( QwtSymbol::Ellipse,
-                                     QBrush( Qt::black ), QPen( myColour ), QSize( 9, 9 ) ) );
-    mypMarker->setLabelAlignment( Qt::AlignHCenter | Qt::AlignTop );
-    QwtText text( QString::number( currentInfo.id ) );
-    text.setColor( myColour );
-    QColor bg( Qt::white );
-    bg.setAlpha( 200 );
-    text.setBackgroundBrush( QBrush( bg ) );
-    mypMarker->setLabel( text );
-    mypMarker->attach( mpSatellitesWidget );
-    mMarkerList << mypMarker;
-  }
-  mpCurve->setData( myXData, mySignalData );
-  mpPlot->replot();
-  if ( mpMapMarker )
-    delete mpMapMarker;
+      QColor bg( Qt::white ); // moved several items outside of the following if block to minimize loop time
+      bg.setAlpha( 200 );
+      QColor myColour;
+      QBrush symbolBrush( Qt::black );
+      QBrush textBgBrush( bg );
+      QSize markerSize( 9, 9 );
+      // Add a marker to the polar plot
+      if ( currentInfo.id > 0 )       // don't show satellite if id=0 (no satellite indication)
+      {
+        QwtPolarMarker *mypMarker = new QwtPolarMarker();
+        mypMarker->setPosition( QwtPolarPoint( currentInfo.azimuth, currentInfo.elevation ) );
+        if ( currentInfo.signal < 30 ) //weak signal
+        {
+          myColour = Qt::red;
+        }
+        else
+        {
+          myColour = Qt::black; //strong signal
+        }
+        mypMarker->setSymbol( QwtSymbol( QwtSymbol::Ellipse,
+                                         symbolBrush , QPen( myColour ), markerSize ) );
+        mypMarker->setLabelAlignment( Qt::AlignHCenter | Qt::AlignTop );
+        QwtText text( QString::number( currentInfo.id ) );
+        text.setColor( myColour );
+        text.setBackgroundBrush( textBgBrush );
+        mypMarker->setLabel( text );
+        mypMarker->attach( mpSatellitesWidget );
+        mMarkerList << mypMarker;
+      } // currentInfo.id > 0
+    } //satellites
+  } //satellite processing loop
+
+  if ( mStackedWidget->currentIndex() == 1 && info.satInfoComplete ) //signal
+  {
+    mpCurve->setData( myXData, mySignalData );
+    mpPlot->replot();
+  } //signal
+
+  if ( mStackedWidget->currentIndex() == 2 && info.satInfoComplete ) //satellites
+  {
+    mpSatellitesWidget->replot();
+  } //satellites
 
-  //after loosing connection, the first gps info sometimes has uninitialized coords
   QgsPoint myNewCenter;
-  if ( doubleNear( info.longitude, 0.0 ) && doubleNear( info.latitude, 0.0 ) )
+  if ( validFlag )
   {
-    myNewCenter = mLastGpsPosition;
+    myNewCenter = QgsPoint( info.longitude, info.latitude );
   }
   else
   {
-    myNewCenter = QgsPoint( info.longitude, info.latitude );
+    myNewCenter = mLastGpsPosition;
   }
 
-  if ( mGroupShowMarker->isChecked() )
+  if ( mStackedWidget->currentIndex() == 0 ) //position
   {
-    mpMapMarker = new QgsGpsMarker( mpCanvas );
-    mpMapMarker->setSize( mSliderMarkerSize->value() );
-    mpMapMarker->setCenter( myNewCenter );
-    mpMapMarker->update();
-  }
-  else
+    mTxtLatitude->setText( QString::number( info.latitude, 'f', 8 ) );
+    mTxtLongitude->setText( QString::number( info.longitude, 'f', 8 ) );
+    mTxtAltitude->setText( tr( "%1 m" ).arg( info.elevation, 0, 'f', 1 ) ); // don't know of any GPS receivers that output better than 0.1 m precision
+    if ( mDateTimeFormat.isEmpty() )
+    {
+      mTxtDateTime->setText( info.utcDateTime.toString( Qt::TextDate ) );  // default format
+    }
+    else
+    {
+      mTxtDateTime->setText( info.utcDateTime.toString( mDateTimeFormat ) );  //user specified format string for testing the millisecond part of time
+    }
+    mTxtSpeed->setText( tr( "%1 km/h" ).arg( info.speed, 0, 'f', 1 ) );
+    mTxtDirection->setText( QString::number( info.direction, 'f', 1 ) );
+    mTxtHdop->setText( QString::number( info.hdop, 'f', 1 ) );
+    mTxtVdop->setText( QString::number( info.vdop, 'f', 1 ) );
+    mTxtPdop->setText( QString::number( info.pdop, 'f', 1 ) );
+    mTxtFixMode->setText( info.fixMode == 'A' ? tr( "Automatic" ) : info.fixMode == 'M' ? tr( "Manual" ) : "" ); // A=automatic 2d/3d, M=manual; allowing for anything else
+    mTxtFixType->setText( info.fixType == 3 ? tr( "3D" ) : info.fixType == 2 ? tr( "2D" ) : info.fixType == 1 ? tr( "No fix" ) : QString::number( info.fixType) ); // 1=no fix, 2=2D, 3=3D; allowing for anything else
+    mTxtQuality->setText( info.quality == 2 ? tr( "Differential" ) : info.quality == 1 ? tr( "Non-differential" ) : info.quality == 0 ? tr( "No position" ) : info.quality > 2 ? QString::number( info.quality) : "" ); // allowing for anything else
+    mTxtSatellitesUsed->setText( QString::number( info.satellitesUsed ) );
+    mTxtStatus->setText( info.status == 'A' ? tr( "Valid") : info.status == 'V' ? tr( "Invalid" ) : "" );
+  } //position
+
+#if 0
+  if ( mStackedWidget->currentIndex() == 4 )    //debug
   {
-    mpMapMarker = 0;
-  }
-  mSpinLatitude->setValue( info.latitude );
-  mSpinLongitude->setValue( info.longitude );
-  mSpinElevation->setValue( info.elevation );
-  mHorizontalAccuracy->setValue( 10 - info.hdop );
-  mVerticalAccuracy->setValue( 10 - info.vdop );
-  mGPSTextEdit->append( "longitude: " + QString::number( info.longitude ) );
-  mGPSTextEdit->append( "latitude: " + QString::number( info.latitude ) );
-  mGPSTextEdit->append( "elevation: " + QString::number( info.elevation ) );
-  mGPSTextEdit->append( "pdop: " + QString::number( info.pdop ) );
-  mGPSTextEdit->append( "hdop: " + QString::number( info.hdop ) );
-  mGPSTextEdit->append( "vdop: " + QString::number( info.vdop ) );
+    QString s;
+    for ( int i = 0; i < info.satPrn.size(); i++ )
+    {
+      if ( info.satPrn.at( i ) > 0 )  //don't show 0 (no satellite)
+      {
+        s.append( QString::number( info.satPrn.at( i ) ).append( " " ) );
+      }
+    }
+    mGPSPlainTextEdit->appendPlainText( "UTC date/time: " + info.utcDateTime.toString() );
+    mGPSPlainTextEdit->appendPlainText( "longitude: " + QString::number( info.longitude, 'f', 8 ) );
+    mGPSPlainTextEdit->appendPlainText( "latitude: " + QString::number( info.latitude, 'f', 8 ) );
+    mGPSPlainTextEdit->appendPlainText( "elevation: " + QString::number( info.elevation ) );
+    mGPSPlainTextEdit->appendPlainText( "speed (knots): " + QString::number( info.speed ) );
+    mGPSPlainTextEdit->appendPlainText( "direction: " + QString::number( info.direction ) );
+    mGPSPlainTextEdit->appendPlainText( "pdop: " + QString::number( info.pdop ) );
+    mGPSPlainTextEdit->appendPlainText( "hdop: " + QString::number( info.hdop ) );
+    mGPSPlainTextEdit->appendPlainText( "vdop: " + QString::number( info.vdop ) );
+    mGPSPlainTextEdit->appendPlainText( "satellites in use: " + s );
+    mGPSPlainTextEdit->appendPlainText( "fix mode: " + QString( info.fixMode ) );
+    mGPSPlainTextEdit->appendPlainText( "fix type: " + QString::number( info.fixType ) );
+  } //debug
+#endif
 
   // Avoid refreshing / panning if we havent moved
   if ( mLastGpsPosition != myNewCenter )
   {
     mLastGpsPosition = myNewCenter;
-    if ( mCbxAutoAddVertices->isChecked() )
-    {
-      addVertex();
-    }
-    // Pan based on user specified behaviour
 
+    // Pan based on user specified behaviour
     if ( radRecenterMap->isChecked() || radRecenterWhenNeeded->isChecked() )
     {
       QgsCoordinateReferenceSystem mypSRS = mpCanvas->mapRenderer()->destinationCrs();
-      QgsCoordinateReferenceSystem myLatLongRefSys = QgsCoordinateReferenceSystem( 4326 );
-      QgsCoordinateTransform myTransform( myLatLongRefSys, mypSRS );
+      QgsCoordinateTransform myTransform( mWgs84CRS, mypSRS ); // use existing WGS84 CRS
 
       QgsPoint myPoint = myTransform.transform( myNewCenter );
       //keep the extent the same just center the map canvas in the display so our feature is in the middle
-      QgsRectangle myRect(
-        myPoint.x( ) - ( mpCanvas->extent( ).width( ) / 2 ),
-        myPoint.y( ) - ( mpCanvas->extent( ).height( ) / 2 ),
-        myPoint.x( ) + ( mpCanvas->extent( ).width( ) / 2 ),
-        myPoint.y( ) + ( mpCanvas->extent( ).height( ) / 2 ) );
+      QgsRectangle myRect( myPoint, myPoint );  // empty rect can be used to set new extent that is centered on the point used to construct the rect
+
+      // testing if position is outside some proportion of the map extent
+      // this is a user setting - useful range: 5% to 100% (0.05 to 1.0)
+      QgsRectangle myExtentLimit( mpCanvas->extent() );
+      myExtentLimit.scale( mSpinMapExtentMultiplier->value() * 0.01 );
 
       // only change the extents if the point is beyond the current extents to minimise repaints
-      if (( !mpCanvas->extent().contains( myPoint ) &&
-            radRecenterWhenNeeded->isChecked() ) ||
-          radRecenterMap->isChecked() )
+      if ( radRecenterMap->isChecked() ||
+           ( radRecenterWhenNeeded->isChecked() && !myExtentLimit.contains( myPoint ) ) )
       {
         mpCanvas->setExtent( myRect );
         mpCanvas->refresh( );
       }
     } //otherwise never recenter automatically
+
+    if ( mCbxAutoAddVertices->isChecked() )
+    {
+      addVertex();
+    }
+  } // mLastGpsPosition != myNewCenter
+
+  // new marker position after recentering
+  if ( mGroupShowMarker->isChecked() ) // show marker
+  {
+    if ( validFlag ) // update cursor position if valid position
+    {                // initially, cursor isn't drawn until first valid fix; remains visible until GPS disconnect
+      if ( ! mpMapMarker )
+      {
+        mpMapMarker = new QgsGpsMarker( mpCanvas );
+      }
+      mpMapMarker->setSize( mSliderMarkerSize->value() );
+      mpMapMarker->setCenter( myNewCenter );
+    }
   }
+  else
+  {
+    if ( mpMapMarker )
+    {
+      delete mpMapMarker;
+      mpMapMarker = 0;
+    }
+  } // show marker
 }
 
+#if 0 // not needed - signals/slots set up in UI file; may be needed in the future if GPS valid is used to control whether button is available (should use enable/disable instead of show/hide)
 void QgsGPSInformationWidget::on_mCbxAutoAddVertices_toggled( bool theFlag )
 {
   if ( theFlag )
@@ -517,6 +756,7 @@ void QgsGPSInformationWidget::on_mCbxAutoAddVertices_toggled( bool theFlag )
     mBtnAddVertex->show();
   }
 }
+#endif
 
 void QgsGPSInformationWidget::on_mBtnAddVertex_clicked( )
 {
